import { OdfElement } from '../OdfElement';
/**
 * This class represents an item in a list.
 *
 * @example
 * const list = document.getBody()
 *   .addList()
 *   .addItem('First item');
 *
 * @since 0.2.0
 */
export declare class ListItem extends OdfElement {
    private paragraph;
    /**
     * Creates a `ListItem` instance that represents an item in a list.
     *
     * @example
     * new ListItem('First item');
     *
     * @param {string} [text=''] The text content of the list item; defaults to an empty string if omitted
     * @since 0.2.0
     */
    constructor(text?: string);
}
