"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const text_1 = require("../api/text");
class AutomaticStyleVisitor {
    constructor(automaticStyles) {
        this.automaticStyles = automaticStyles;
    }
    visit(odfElement) {
        if (odfElement instanceof text_1.Heading) {
            this.visitHeading(odfElement, this.automaticStyles);
        }
        else if (odfElement instanceof text_1.Paragraph) {
            this.visitParagraph(odfElement, this.automaticStyles);
        }
        odfElement.getAll().forEach((odfChildElement) => {
            this.visit(odfChildElement);
        });
    }
    visitHeading(heading, automaticStyles) {
        const style = heading.getStyle();
        if (style === undefined) {
            return;
        }
        automaticStyles.add(style);
    }
    visitParagraph(paragraph, automaticStyles) {
        const style = paragraph.getStyle();
        if (style === undefined) {
            return;
        }
        automaticStyles.add(style);
    }
}
exports.AutomaticStyleVisitor = AutomaticStyleVisitor;
